@using Jones.AspNetCore.Extensions
@using Jones.AspNetCore.Models
@inherits Jones.AspNetCore.Components.Forms.FilesInputBase

<div class="flex flex-col gap-2">
    @if (LabelContent != null)
    {
        @LabelContent
    }
    
    <div class="flex flex-wrap items-center gap-4">
        
        @if (InitFiles?.Any() == true)
        {
            foreach (var file in InitFiles)
            {
                <FileInputPreview OnDelete="() => DeleteInitFiles(file)">
                    @DoCreateInitImagePreview(file, InitFiles)
                </FileInputPreview>
            }
        }

        @foreach (var file in Files)
        {
            <FileInputPreview OnDelete="() => Delete(file)">
                @if (file.IsImage())
                {
                    <img src="@file.GetImageSrc()" alt="预览"/>
                }
                else
                {
                    @if (CreatePreviewIcon != null)
                    {
                        @CreatePreviewIcon(file)
                    }
                    @* <i class="@file.PreviewFromBootstrapIcons()"></i> *@
                }
            </FileInputPreview>
        }

        <div class="@(Files.Length + (InitFiles?.Length ?? 0) < MaximumFileCount ? null : "hidden")">
            <FileInput OnChange="@OnFilesChange" OnError="OnFilesError" Placeholder="@Placeholder" IsAllowDrop="IsAllowDrop" IsAllowPaste="IsAllowPaste" Accept="@Accept"
                       IsMultiple="IsMultiple" MaxFileSize="MaxFileSize" MaximumFileCount="MaximumFileCount" IsRequired="IsRequired"/>
        </div>
    </div>
</div>

@code
{
    [Parameter]
    public Func<FileViewModel, RenderFragment>? CreatePreviewIcon { get; set; }
    
    [Parameter]
    public Func<string, string[], RenderFragment>? CreateInitImagePreview { get; set; }
    
    [Parameter]
    public Func<string[], RenderFragment>? CreateInitFilesPreview { get; set; }

    private RenderFragment DoCreateInitImagePreview(string src, string[] files)
    {
        return CreateInitImagePreview == null ? CreateDefaultPreview(src) : CreateInitImagePreview.Invoke(src, files);
    }
    
    private RenderFragment CreateDefaultPreview(string src) => @<img src="@src" alt="预览"/>;
}
